#include "stdafx.h"
#include "gaugebar.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


IMPLEMENT_DYNAMIC(CGaugeBar, CStatusBar)

BEGIN_MESSAGE_MAP(CGaugeBar, CStatusBar)
	//{{AFX_MSG_MAP(CGaugeBar)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

CGaugeBar::CGaugeBar()
{
	m_nPercent = 0;
}

void CGaugeBar::SetPercent(int percent)
{
	ASSERT(percent >=0 && percent <= 100);

	// Always repaint if percent == 0
	if (!percent && percent == m_nPercent)
		return;

	m_nPercent = percent;

	// Only invalidate the panes with the SBPS_PERCENT style
	// incase other panes 
    
	int nIndex, cxWidth;
	UINT nId, nStyle;
	CRect paneRect;
		
	for (nIndex = 0; nIndex < GetCount(); nIndex++)
	{
		GetPaneInfo(nIndex, nId, nStyle, cxWidth);
		if (nStyle & SBPS_PERCENT)
		{
			GetItemRect(nIndex, paneRect);
			InvalidateRect(paneRect);			
		}
	} 
}

void CGaugeBar::DoPaint(CDC* pDC)
{
	int nIndex;
	UINT nId, nStyle;
	int cxWidth;
	CRect paneRect;

	CStatusBar::DoPaint(pDC);     // paint status bar first

	for (nIndex = 0; nIndex < GetCount(); nIndex++)
	{
		GetPaneInfo(nIndex, nId, nStyle, cxWidth);
		if (nStyle & SBPS_PERCENT)
		{
			GetItemRect(nIndex, paneRect);

			// Make a copy of the rectangle surrounding the pane and decrease 
			// the right side of the rectangle by a percentage if its width
			paneRect.right = paneRect.left + (int) 
				(paneRect.Width() * (min(m_nPercent, 100) / 100.0));
		
			// If there is a 3D border, adjust the bottom by one pixel so we 
			// don't end up inverting the white line at the bottom of the pane
			if (!(nStyle & SBPS_NOBORDERS) )
				paneRect.bottom--;
	
			pDC->InvertRect(paneRect);			
		}
	}
}
